(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
 Affiche les paramtres transmis (comme 'ParamStr(i)').                     
                                                                            
                           Stucture du PSP                                  
     Ŀ      
      Pos  Oct  Description                                             
     Ĵ      
        0    2  Code de l'interruption 20h                              
        2    2  Segment de fin de programe                              
        4    1  - rserv -                                             
        5    1  Code pour 'call for'                                    
        6    4  Adresse de l'interruption 21h                           
       10    4  Adresse de l'interruption 22h (mettre fin)              
       14    4  Adresse de l'interruption 23h (arrt)                   
       18    4  Adresse de l'interruption 24h (erreur)                  
       22   22  - rserv -                                             
       44    2  Segment du bloc d'environnement                         
       46   34  - rserv -                                             
       80    2  Code pour l'interruption 21h                            
       82    1  Code pour 'retf'                                        
       83    9  - rserv -                                             
       92   16  FCB standart, numro 1                                  
      108   20  FCB standart, numro 2                                  
      128    1  Nombre de caractres dans la ligne de commande          
      129  127  Chaine de paramtres du programme                       
           
                                                                            
*)

{$M 2048,0,0}

uses EcranTxt;

var txt,txt2 : string;

procedure ExtraitPsp (var Parametre: string); assembler; asm
  push ds                    { Sauve DS (vaut mieux)                         }

  mov ah,62h                 { Fonction 62h : Lecture du PSP                 }
  int 21h                    { Appel l'interruption gnrale de DOS          }
  { Sortie : BX = Segment du PSP }

  mov ds,bx                  { DS:SI -> (Source) Pointe sur le PSP           }
  mov si,80h                 { SI = 80h -> Paramtres transmis               }
  les di,[Parametre]         { ES:DI -> (Destination) Pointe sur la variable }
  mov cx,128/4               { CX = Longueur  copier (128 octets = 32x4)    }
{ rep movsd } db 66h; rep movsw   { Effectue la copie en 32 bits             }

  pop ds                     { Recharge DS                                   }
end;

begin
  EffaceEcranTxt;

  ExtraitPsp (txt);

  if txt<>'' then begin
    Ecrit ('Les paramtres suivant ont t transmis (long de ');
    EcriTnc (length(txt),10);
    EcriTr (' octets)');

    Ecrit  ('>');
    EcriTc (txt,15);
    EcriTr ('<');
  end else begin
    EcriTcr ('Aucun paramtre n''a t transimit !',11);
  end;
  EcriTr ('');
end.